/************************************************************************************/
/*  Program name CAPGLEXT_VALUES.sql                                            */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 9 JAN, 2005   NIP Karen         First created                                    */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_VALUES';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_VALUES.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		FFV.*
	FROM   
		FND_FLEX_VALUES			FFV
    ,	FND_FLEX_VALUE_SETS		FFVS
	WHERE	FFVS.FLEX_VALUE_SET_ID	=	FFV.FLEX_VALUE_SET_ID
	AND		UPPER(SUBSTR(FFVS.FLEX_VALUE_SET_NAME,1,4))	=	UPPER(p_NGO);

BEGIN
	lv_NGO_Name		:=	UPPER('&NGO_Code');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.FLEX_VALUE_SET_ID||CHR(9)||
				C1.FLEX_VALUE_ID||CHR(9)||
				C1.FLEX_VALUE||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.ENABLED_FLAG||CHR(9)||
				C1.SUMMARY_FLAG||CHR(9)||
				C1.START_DATE_ACTIVE||CHR(9)||
				C1.END_DATE_ACTIVE||CHR(9)||
				C1.PARENT_FLEX_VALUE_LOW||CHR(9)||
				C1.PARENT_FLEX_VALUE_HIGH||CHR(9)||
				C1.STRUCTURED_HIERARCHY_LEVEL||CHR(9)||
				C1.HIERARCHY_LEVEL||CHR(9)||
				REPLACE(C1.COMPILED_VALUE_ATTRIBUTES,CHR(10),'@')||CHR(9)||
				C1.VALUE_CATEGORY||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.ATTRIBUTE21||CHR(9)||
				C1.ATTRIBUTE22||CHR(9)||
				C1.ATTRIBUTE23||CHR(9)||
				C1.ATTRIBUTE24||CHR(9)||
				C1.ATTRIBUTE25||CHR(9)||
				C1.ATTRIBUTE26||CHR(9)||
				C1.ATTRIBUTE27||CHR(9)||
				C1.ATTRIBUTE28||CHR(9)||
				C1.ATTRIBUTE29||CHR(9)||
				C1.ATTRIBUTE30||CHR(9)||
				C1.ATTRIBUTE31||CHR(9)||
				C1.ATTRIBUTE32||CHR(9)||
				C1.ATTRIBUTE33||CHR(9)||
				C1.ATTRIBUTE34||CHR(9)||
				C1.ATTRIBUTE35||CHR(9)||
				C1.ATTRIBUTE36||CHR(9)||
				C1.ATTRIBUTE37||CHR(9)||
				C1.ATTRIBUTE38||CHR(9)||
				C1.ATTRIBUTE39||CHR(9)||
				C1.ATTRIBUTE40||CHR(9)||
				C1.ATTRIBUTE41||CHR(9)||
				C1.ATTRIBUTE42||CHR(9)||
				C1.ATTRIBUTE43||CHR(9)||
				C1.ATTRIBUTE44||CHR(9)||
				C1.ATTRIBUTE45||CHR(9)||
				C1.ATTRIBUTE46||CHR(9)||
				C1.ATTRIBUTE47||CHR(9)||
				C1.ATTRIBUTE48||CHR(9)||
				C1.ATTRIBUTE49||CHR(9)||
				C1.ATTRIBUTE50||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No segment values for this NGO service unit segment';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
